// YAServerDlg.h : ͷļ
#pragma once
#include "afxwin.h"
#include "resource.h"
#include "structdef.h"
#include "constdef.h"
#include "def_msg.h"
#include "socketdef.h"
#include "ReportCtrl/ReportCtrl.h"
#include <sio_client.h>
#include "../thirdparty/include/iocp/Src/TcpServer.h"
#include "../thirdparty/include/iocp/Global/helper.h"
#include "afxcmn.h"
#include "./SyncTime/SyncManager.h"
#include "classdef.h"
#include "QueueStrManager.h"
#include "uwb_msg_def.h"
#include <json/json.h>
#include "MysqlConnPool.h"

extern BOOL m_log_sys_status;

using namespace sio;
using namespace std;
using namespace HostServer;

struct  _SLS // system_limit_setting
{
	unsigned int over_count_person;
	unsigned int over_count_vehicle;
	unsigned int over_time_person;
	unsigned int over_time_vehicle;
	double over_speed;
};

struct _DBS // db setting
{
	string host;
	string user;
	string password;
	string dbname;
	string encoding;
	int port;
};

struct _SOCK
{
	CString sip;
	DWORD dwConnID;
	int state; // 0 
	DWORD reader_id; // վ
	DEVICE_TYPE reader_type; // ͨŷվվ
};

struct _SOCKET_BUFFER
{
	DWORD dwConnID;
	BYTE pData[LENGTH_MSG_1M]; 
	WORD wLen;
	WORD wReadLen;

	_SOCKET_BUFFER(){
		dwConnID = 0;
		wLen = 0;
		wReadLen = 0;
		memset(pData,0,LENGTH_MSG_1M*sizeof(BYTE));
	}
};

//extern DWORD WINAPI _exec_sql(LPVOID lparam);
extern DWORD WINAPI _exec_sql(const char* lparam);
extern DWORD WINAPI _write_error_log(LPVOID lparam);

// CYAServerDlg Ի
class CYAServerDlg : public CDialogEx, public CTcpServerListener
{
	typedef map<string, std::shared_ptr<Card>> CardMap;
	typedef map<CString, std::shared_ptr<_SOCK>> SocketMap;
	typedef map<CString, std::shared_ptr<_SOCKET_BUFFER>> SocketBufferMap;
	typedef map<INT64, std::shared_ptr<YaEvent>> EventMap;
	typedef map<int, std::shared_ptr<LightCallInfo>> LightCallMap;

	struct LogMsg
	{
		CString strFile;
		CString strLog;
		bool isNeedTime;
	};
	struct DataMsg
	{
		CONNID dwConnID;
		int iLength;
		BYTE* pData;		
	};
	// 
public:
	CYAServerDlg(CWnd* pParent = NULL);	// ׼캯
	~CYAServerDlg();
	// Ի
	enum { IDD = IDD_YASERVER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧
private:
	virtual EnHandleResult OnPrepareListen(ITcpServer* pSender, SOCKET soListen);
	virtual EnHandleResult OnAccept(ITcpServer* pSender, CONNID dwConnID, SOCKET soClient);
	virtual EnHandleResult OnSend(ITcpServer* pSender, CONNID dwConnID, const BYTE* pData, int iLength);
	virtual EnHandleResult OnReceive(ITcpServer* pSender, CONNID dwConnID, const BYTE* pData, int iLength);
	virtual EnHandleResult OnClose(ITcpServer* pSender, CONNID dwConnID, EnSocketOperation enOperation, int iErrorCode);
	virtual EnHandleResult OnShutdown(ITcpServer* pSender);
	virtual void OnReConnect(unsigned, unsigned);
	// ʵ
protected:
	HICON m_hIcon;

	// ɵϢӳ亯
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	CButton m_btStart;
	CButton m_btStop;
	CMenu m_mnMain;
	afx_msg LRESULT on_monitor(WPARAM wParam, LPARAM lParam);
	afx_msg void OnBnStop();
	afx_msg void OnBnStart();	
	afx_msg void OnBnExit();
	afx_msg void OnBnSyncTime();
	afx_msg void OnMenuDb();
	afx_msg void OnMenuLog();
	afx_msg void OnMenuParam();
	afx_msg void OnBnCallHisData();
public: 
	// ui operation
	CTcpServer _server;
	HostServer::SyncManager syncmanager;
	EnAppState m_enState;
	CStdioFile cfErrorLog;
	CRITICAL_SECTION m_csWriteLog;
	CRITICAL_SECTION m_csRemoveSocket;
	CRITICAL_SECTION m_csRefreshList;
	CRITICAL_SECTION m_csParseDataServer;
	CRITICAL_SECTION m_csSyncTime;
	CRITICAL_SECTION m_csCallInfo;

	QueueStrManager* m_qsmSQL;

	bool is_start_tcp;
	void set_app_state(EnAppState eas);
	void start_tcp_server();
	void stop_tcp_server();	
public:
	CString m_strConncetion; // ݿַ
	int m_nPort; // ˿
	int m_nCountClick;

	CWinThread* m_thread_monitor; // سͨ߳
	CWinThread* m_thread_timer; // timeṛ߳UỊ߳ʹontimer
	unsigned int m_uint_state; // ɼ״̬
	// bit 0, ״̬л߹ر
	// bit 1, ɼ״̬쳣
	// bit 2, վ״̬жϻû
	// bit 3, websocket״̬δ
	// bit 4, ݿ״̬δ
	time_t m_time_last_rec; // յվݵʱ
	bool is_websocket_ok; 
	bool is_websocket_login;
	// web
	bool is_websocket_login_ex;
	bool is_websocket_ok_ex;
	
	bool is_server_ok; 
	bool is_database_ok; 

	int m_shift_id;
	BOOL m_bUseFilter;

	int m_nFilterType;
	int m_nMallocTimes;

	//BOOL m_log_sys_status;
	BOOL m_log_raw_data;
	BOOL m_log_parse_data;
	BOOL m_log_send_package;
	BOOL m_log_recv_package;
	BOOL m_log_locate_data;

	SocketMap mp_socket_list;
	SocketBufferMap mp_socket_buffer_list;

	ReaderMap mp_reader_list; // зվ
	ReaderMap mp_ctrl_reader_list; // пƷվ
	AreaMap mp_area_list; // 
	DrivingfaceWarningPointMap mp_drivingface_warning_point_list; // 澯б
	DrivingfaceWarningPointMapAll mp_drivingface_warning_point_list_all;//澯ȫб
	SpecilaAreaEntryMap mp_special_area_entry_list; //
	DrivingfaceRenderMap mp_driving_face_render_list; //վϢ
	DrivingfaceCardMap mp_driving_face_card_list;//ʶϢ lemon
	WorkTypePermissionMap mp_worktype_permission_list;// lemon 2017/07/31
	RulesMap m_rules_list;
	MapInfoMap mp_map_list; // еͼ
	LandmarkInfoMap mp_landmark_list; // еͼر
	MapDirectionInfoMap mp_map_direction_list; //ͼϵXļн
	DeptMap mp_dept_list; // в
	BanShiftMap mp_banshift_list; // Ϣ
	OccLevelMap mp_occlevel_list; // ְ񼶱
	AlarmTypeMap mp_alarm_type_list;
	SectionMap mp_section_list;
	ChamberMap mp_chamber_list;
	LightMap   mp_light_list;
	LightGroupMap mp_light_group_list;

	CardMap mp_card_list_all; // п
	CardMap mp_card_list_down_vehicle; // ³
	CardMap mp_card_list_down_person;  // Ա
	CardMap mp_card_list_up_person; // Ա
	CardMap mp_card_list_down_adhoc;   //
	PatrolTaskCheckMap mp_card_task_list; // Ѳ
	LeaderArrangeMap mp_leaderarrange_list; // 쵼
	VehicleTypeAttRuleMap mp_att_area_list; // бͬͣܲͬ

    std::shared_ptr<ReaderPathMap> mp_reader_path_list_tof;	//ǰͼзվĸǷΧ
	std::shared_ptr<TDOAReaderPathMap> mp_reader_path_list_tdoa; 
	std::shared_ptr<CardMap> mp_card_list_over_time_person;	// ʱԱ	
	std::shared_ptr<CardMap> mp_card_list_forbidden_person; // Ա
	std::shared_ptr<CardMap> mp_card_list_help; // Ա
	std::shared_ptr<CardMap> mp_card_list_area_over_time_person; // ʱԱ
	std::shared_ptr<CardMap> mp_card_list_forbidden_vehicle; // 
	std::shared_ptr<CardMap> mp_card_list_over_time_vehicle; // ʱ
	std::shared_ptr<CardMap> mp_card_list_over_speed_vehicle; // ٳ
	std::shared_ptr<CardMap> mp_card_list_area_over_time_vehicle; // ʱ
	std::shared_ptr<CardMap> mp_card_list_over_count_person; // ԱԱ
	std::shared_ptr<CardMap> mp_card_list_over_count_vehicle; //Ա

	std::shared_ptr<AreaMap> mp_area_over_count_person; // ԱԱ
	std::shared_ptr<AreaMap> mp_area_over_time_person; // Աʱ
	std::shared_ptr<AreaMap> mp_area_forbidden_person; // 
	std::shared_ptr<AreaMap> mp_area_over_count_vehicle; // Ա
	std::shared_ptr<AreaMap> mp_area_over_time_vehicle; // ʱ
	std::shared_ptr<AreaMap> mp_area_forbidden_vehicle; // г

	std::shared_ptr<CardMap> mp_card_warning_point_alarm;//lemon
	std::shared_ptr<CardMap> mp_card_drivingface_eara_alarm;//lemon 20017/07/31 Ա澯
	std::shared_ptr<EventMap> mp_event_list; // ¼б
	std::shared_ptr<LightCallMap> mp_light_call_list; // ƺ̵б

	unordered_map<unsigned long long, unsigned short> umpRootSyncNum;  // ÿrootͬ

	CallInfoUserMap mp_user_call_info; // ûϢ

	_SLS sls_setting; // ϵͳ
	_DBS m_db_setting; // ݿ
	_DBS m_db_setting_bk; // ݿ
	string m_ws_url; // weburl
	string m_ws_url_ex; // url
	CString m_tcp_host; // շվݵip

	double m_reader_interval_time;
	INT64 m_event_list[MINE_EVENT_COUNT];
	int cur_shift_id;
	time_t cur_shift_start_time;
private:
	int init_smart_pointer_var();
private: //lemon
	//int m_drivingfaceWarningIdForMinDis;
public:
	void init_ui(); // ʼ
	void init_param(); // ʼв
	void init_queuestring(); // ʼݿ⻺
	void load_param_from_ini(); // ļв
	void database_connect(); // ݿ
	void stop_and_exit(); // ֹͣ˳
	void set_run_state(); // ޸Ľ水ť״̬

	// ݿгʼ 
	void init_base_data(); // 
	int init_setting(); // ϵͳ
	int init_alarm_type(); // 
	int init_shift(); // Ϣ
	int init_dept(); // б
	int init_level(); // 
	int init_card(string card_id = "");
	int init_staffer(string staff_id = "", bool is_card = false); // Ա
	int init_vehicle(string vehicle_id = "", bool is_card = false); // 
	int init_adhoc(string adhoc_id = "",bool is_card = false); // 
	int init_map(int map_id = 0); // ͼ
	int init_landmark(void); //·Ϣ
	int init_map_direction(void);//ͼϵXϵļн
	int init_area(int area_id = 0); // 
	int init_special_area_entry(void); // 
	int init_drivingface_render(void); //վ׼
	int init_drivingface_card(void);//lemon init drivingface_card..
	int init_drivingface_permission_card(void);//lemon 2017/07/31
	int init_reader(int reader_id = 0); // վ
	int init_ctrl_reader(int reader_id = 0); // Ʒվ
	int init_antenna(int reader_id = 0); // 
	int init_dev_adhoc(int reader_id = 0); // 
	int init_antenna_sync(); // ʼվ룬װʱͬ
	int init_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int init_tof_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int init_tdoa_all_readers_coverage(int reader_id = 0);			//ݿȡͼǷΧ,ʼзվĵͼ
	int init_traffic_lights(int light_id = 0);		//ʼ̵
	int init_chamber(int chamber_id = 0);				//ʼ
	int init_section(int section_id = 0);				//ʼ·
	int init_light_group(int group_id = 0);				//ʼ̵
	int init_light_state(CONNID dwConnID,std::string strIp);
	int init_rules(int rule_id = 0); // ʼ 2017/08/01
	int init_leader_arrange(); // 쵼Ű
	void clear_leader_arrange(); // б
	void clear_att_area();

	//int init_patrol_info(int task_id = 0); // ѲѲ·
	int init_patrol_info(std::string card_id);
	int delete_patrol_info(std::string card_id);
	int get_help_card_nums();
	int init_att_area(); // 뿼Ϣ

	// ʷ
	void load_his_data();
	void load_his_area(); // 
	void load_his_reader(); // վ״̬
	void load_his_card_postion_vehicle(); // λ
	void load_his_card_postion_staff();
	void load_his_driving_face_card_postion(); // λ

	void load_his_driving_face_card_state(); // 濨״̬
	void init_drivingface_warning_point();
	void load_his_card_state(); // ؿ״̬
	void load_drivingface_card_curshift_position();//ʷмؾĳʼ״̬ǰεĿʼֵ
	float get_drivingface_warning_point_dis(std::shared_ptr<Card> card);

	// 뱨
	void load_alarm_reader();

	MYSQL_RES* getMysqlRes(const char* sql);
	// ӿݽ
	void parse_edit_map(int map_id);
	void parse_edit_area(int area_id);
	void parse_edit_reader(int reader_id);
	void parse_edit_card(string card_id);
	void parse_edit_staffer(string staffer_id);
	void parse_edit_vehicle(string vehicle_id);
	void parse_edit_path(int path_id);
	void parse_set_limit_value();
	void parse_call_card();
	void parse_clear_card();
	void parse_deal_help();
	// ʼwebsocket
	void ws_init();
	void ws_open();
	void ws_close();
	void ws_login();
	void ws_logout();

	void ws_init_ex();
	void ws_open_ex();
	void ws_login_ex();
	void ws_logout_ex();

	void clear_listener();
	void clear_all_list();
	// socket
	void parse_data_server(const BYTE * pData, int nLen, DWORD dwConnId); // ճ
	void parse_package_data(BYTE* DataBuffer, int nLen, DWORD dwConnID); // ͻճ
	// λ
	void parse_data_locate_reader(BYTE * DataBuffer, int& nCurPos, int nLen, DWORD dwConnID, int& reader_id);
	void parse_data_ctrl_reader(BYTE * DataBuffer, int& nCurPos, int nLen, DWORD dwConnID, int& reader_id);
    int parse_inav_msg(INAVLocateMsg* msgPtr);
	void deal_inav_locate_msg(INAVLocateMsg* msgPtr, int card_num);
	INAV_STATUS calculate_inav_state(INAVLocateData* cardData);
	void calculate_inav_locate_by_magic(std::shared_ptr<Card> card, INAVLocateData* cardData);
	void write_inav_locate_magic_data(std::shared_ptr<Card> card, INAVLocateData* cardData);
    void log_card_inav_state(INAV_STATUS card_state, string card_id);
	void parse_data_lights_state(BYTE* DataBuffer, int& nCurPos, int reader_id, unsigned short wChr);
	int parse_data_locate_card(BYTE* DataBuffer, int& nCurPos, int reader_id, unsigned short wChr);
	int get_locate_msg_type(BYTE* DataBuffer);
	std::shared_ptr<Card> parse_tof_locate_msg(TofLocateMsg* DataBuffer, int cardNum);
	
	void parse_data_locate_card_vehicle(BYTE* DataBuffer, int& nCurPos,  std::shared_ptr<Card> card, unsigned short wChr);
	void parse_data_locate_reader_his(BYTE * DataBuffer, int nLen, int& nCurPos, int& reader_id, int& nTick, CString& strtime, unsigned short wChr);
	void parse_data_locate_card_his(BYTE* DataBuffer, int& nCurPos, int reader_id, DWORD wTickCount, CString strTime, unsigned short wChr);
	void parse_data_locate_card_his_tdoa(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime);
	void parse_data_locate_card_his_tdoa_package(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_tof_card(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_tdoa_card(BYTE* DataBuffer, int nLen, int reader_id, DWORD wTickCount, CString strTime, CString strHistTime);
	void parse_data_locate_card_his_sync_time(BYTE* DataBuffer, int nLen, CString strTime,  CString strHistTime, WORD wChr);
	// 
	void parse_data_adhoc(BYTE* DataBuffer, int& nCurPos,  int reader_id);
	// վʱͬ
	void parse_data_reader_synctime(BYTE *DataBuffer, int nLen, int& nCurPos, WORD wChr);

	std::shared_ptr<_SOCK> get_socket_by_Id(DWORD dwConnID);
	void add_socket_to_list(DWORD dwConnID, DWORD reader_id, DEVICE_TYPE rt);
	void remove_socket(DWORD dwConnID);
	// 
	//void SendData(DWORD dwConnID, WORD wCharacterWord, int wLength, BYTE* DataBuffer);
	BOOL SendData(DWORD dwConnID, WORD wCharacterWord, int wLength, BYTE* DataBuffer);
	// õĵӵб,ͬһƵ״̬Ḳǣʹһ״̬
	void add_light_to_call_list(LIGHTS_SELECT_TYPE lst, LIGHT_COLOR clr, LIGHT_CTRL_STATE ctrl, int tkid, LIGHT_SHAPE ls,int light_id = 0); 
	void send_call_light();
	void send_call_light(BYTE ctrl_cmd, int light_id, int ctrl_type, int ctrl_color,int light_shape);

	// ȡjson
	string get_json_login();
	string get_json_logout();
	bool   need_display_verification(std::shared_ptr<Card> card); //ǷҪ false Ҫ true ִ
	string get_json_down_and_up(std::shared_ptr<Card> card); // 뾮ӿ,뾮ʱ
	string get_json_special_area_process(std::shared_ptr<Card> card); // ӿڣʶźŶʧҵжϳӦʱ
	string get_json_all_special_area_data(); // ĳǰ˵¼ʱȫ
	string get_json_position(); // ʵʱλϢӿڣһ === ûget_json_card_statistic
	string get_json_drivingface_card_position(std::shared_ptr<Card> card); // done
	string get_json_position_all(); // ʵʱλϢǰû¼ʱϱ ==== handle this function : get_json_card_statistic
	int insert_data(int index, int key, StatisticDataStr** header); // û
	void delete_memory(StatisticDataStr *header);
	//int get_json_statistic_vehicle_data(Json::Value& vehicle_data);

	//˼ƽ޶ĴPart 11/Sum 11:begin ڣYAServerDlg.h
	//by lsp on 2017.07.10 @ɽ
	//˼ƽ޶ĴPart 10/Sum 10:begin ڣYAServerDlg.h
	//by lsp on 2017.07.09 @ɽ
	//int get_json_statistic_vehicle_data(Json::Value& vehicle_data);
	//int get_json_statistic_staff_data(Json::Value& person_data);
	Json::Value get_json_statistic_vehicle_data(Json::Value& vehicle_data);
	Json::Value get_json_statistic_staff_data(Json::Value& staff_data);
	Json::Value get_json_statistic_data(StatisticDataStr* header); // ÿ뷢ͳݣпλϢԱ  == еݳjson
	int get_json_node_position(std::shared_ptr<Card> card,Json::Value& detailNode);
	string get_json_card_statistic();//handle get_json_statistic_vehicle_data  get_json_statistic_staff_data
	string get_json_all_data(); // ǰû¼ʱ
	string get_json_device_state(); // վ״̬Ϣ
	string get_json_help();			//json
	string get_json_event(bool bAll = false);

	string get_json_call_list(); // б not handle
	string get_json_new_device_state(); // վ״̬Ϣ
	string get_json_count_area();	//ͳ not handle
	string get_json_leader_arrange(); // 쵼

	Json::Value get_section_json_alarm(); // ·θ澯
	Json::Value get_light_json_alarm(); // ̵Ƹ澯
	Json::Value get_red_light_json_alarm(); // Ƹ澯

	void send_json_data(string cmd, string data, bool is_login = false);
	// ҵ
	void deal_readers();
	void deal_areas();
	void deal_attendace(std::shared_ptr<Card> card);
	void deal_card_msg(std::shared_ptr<Card> card, bool is_hist = false);
	void cal_card_position_by_msg(std::shared_ptr<Card> card);
	void deal_hist_card_postion();
	void deal_his_card_list(std::shared_ptr<Card> card);

	void card_enter_mine(std::shared_ptr<Card> card);
	void card_enter_mine(std::shared_ptr<Card> card, POS_DEVICE_TYPE pdt);
	void card_down_mine(std::shared_ptr<Card> card);
	void card_up_mine(std::shared_ptr<Card> card);
	void card_enter_map(std::shared_ptr<Card> card);
	void card_enter_area(std::shared_ptr<Card> card);
	void card_enter_special_area(std::shared_ptr<Card> card, int area_id);
	void card_leave_area(std::shared_ptr<Card> card, std::shared_ptr<Area> area);
	void deal_card_state(std::shared_ptr<Card> card);
	void deal_card_drivingface_permission(std::shared_ptr<Card> card);
	void deal_alarm_card(std::shared_ptr<Card> card, std::shared_ptr<CardMap> dest_card_list, bool is_alarm, ALARM_FLAG tag);
    void deal_drivingface_alarm(std::shared_ptr<Card> card, bool is_alarm, ALARM_FLAG tag);
	void deal_drivingface_alarm_all();
	void deal_alarm_area(std::shared_ptr<Area> area, std::shared_ptr<AreaMap> dest_area_list, bool is_alarm, ALARM_FLAG tag,int tyep);
	void deal_card_lost_state();
	int get_special_area_id(shared_ptr<Card> card);
	int  deal_traffic_lights(std::shared_ptr<Card> card);
	int  deal_area_over_speed(std::shared_ptr<Card> card);		//
	int  card_enter_chamber(std::shared_ptr<Card> card,std::shared_ptr<Section> section);
	int  select_pos_output(std::shared_ptr<Card> card);
	void reset_map_card();
	bool is_in_rectangle(_point p, double dblleft, double dbltop, double dblright, double dblbottom);
	bool is_in_circle(_point p1, _point p2, double r, double scale);
	// save to database
	void execute_sql(const char* sql); // 浽ݿ

	void deal_card_drivingface_real(std::shared_ptr<Card> card);
    void calculate_card_postion_by_tof(std::shared_ptr<Card> card); // 濨λ
    void process_driving_face_start_service(std::shared_ptr<Card> card); // ɾ
    void send_drivingface_card_position_json();
    void write_drivingface_shift_start_data(std::shared_ptr<Card> card);
	void write_drivingface_shift_end_data(std::shared_ptr<Card> card);
    void driving_face_shift_start();
	void driving_face_shift_end();
    void process_driving_face_end_service(std::shared_ptr<Card> card);
	void store_driving_face_data(std::shared_ptr<Card> card);
	void update_driving_face_data(std::shared_ptr<Card> card);//lemon changed..2017/07/29
	void write_his_drivingface_real(std::shared_ptr<Card> card);
	void save_card_postion(std::shared_ptr<Card> card); // 濨λ
	void save_raw_data_card_tof(std::shared_ptr<Card> card);
	void save_card_postion_ex(std::shared_ptr<Card> card); // ¼
	bool IsInLine(_point p1, _point p2, _point p3);

	void store_data_card(std::shared_ptr<Card> card, int tag);
	void store_data_event(std::shared_ptr<YaEvent> ev);
	void save_patrol_data(std::shared_ptr<PatrolTask> pTask, std::shared_ptr<PatrolPoint> pPoint);

	int  store_data_light(std::shared_ptr<Light> light,int tag);
	int  store_data_traffic_red_light(std::shared_ptr<Light> light,std::shared_ptr<Card> card);	//洢
	int  store_data_section(std::shared_ptr<Section> section,time_t cur_time,int tag);

	// 
	void package_data();
	// ͨ÷
	int API_TimeToString(string &strDateStr,const time_t &timeData);
	int API_StringToTime(const string &strDateStr,time_t &timeData);
	//void formatByteArray(CString &strBuf, BYTE * buf, int nLen);
	void formatByteArray(std::string &strBuf, BYTE * buf, int nLen);
	void writeErrorLog(const CString strFile, const CString strErr ,bool bTime = true);
	void writeErrorLogEx(const CString strFile, const CString strErr ,bool bTime = true);
	void writeErrorLogEx(const char* strFile, const char* strErr ,bool bTime = true);
	BOOL openLogFile(const CString strFile);
	BOOL openLogFile(const char* strFile);
	void show_log( LPCTSTR szlog, BOOL bSave = true);
	void AddItem(CString strvalue, int readerid, BOOL is_closed, DEVICE_TYPE rt);
	// Ӧӿ
	void parse_json_data_set_limit_value(const char* sz);
	void parse_json_data_call_card_cancel(message::ptr const& data);
	void parse_json_data_call_card(message::ptr const& data);//(const char* sz);
	void parse_json_data_clear_card(message::ptr const& data);
	void parse_json_data_deal_help(const char* sz);
	int  parse_json_data_set_light_color(message::ptr const& data);
	int  parse_json_data_request_counts_info(message::ptr const& data);
	int parse_json_data_reader_pos_change(message::ptr const& data);

	void deal_call_edit_map(int id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_area(int id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_reader(int id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_card(string id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_staff(string id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_vehicle(string id, EDIT_TYPE_ID edit_type_id);
	void deal_call_edit_adhoc(string id, EDIT_TYPE_ID edit_type_id);
	int  deal_call_edit_section(int id,EDIT_TYPE_ID edit_type_id);		//web˱༭·Ϣ
	int  deal_call_edit_light(int id,EDIT_TYPE_ID edit_type_id);		//web˱༭Ϣ
	int  deal_call_edit_chamber(int id,EDIT_TYPE_ID edit_type_id);		//web˱༭Ϣ
	void deal_call_edit_rules(int id,EDIT_TYPE_ID edit_type_id);//lemon 2017/08/01

	void deal_call_edit_patrol_task(string id, EDIT_TYPE_ID edit_type_id);
	void remove_card(string card_id);
	void clear_card_from_list(std::shared_ptr<Card> card);

	void add_event(std::shared_ptr<YaEvent> ev);
	void remove_event(std::shared_ptr<YaEvent> ev);

	void check_patrol();
	void send_call_info();
	void send_call_his_data();
	void send_sync_reader();
	int send_heart_package();
	void clear_call_info();
	int get_card_id_len(int card_type);
	int modify_card_speed(int val);

	bool is_has_chamber(int section_id);	//·ڴڿõ
	bool isInMainTunel(std::shared_ptr<Card> pCard);		//˿Ƿ
	int getTunelProperty(std::shared_ptr<Card> pCard);		//ÿֵ
	void AnalysisAlgoFailedData(int interval = 60000 /*std::shared_ptr<Card> pCard*/);

	int GetLandmarkID(_point card_point);
	double GetDistance(_point p1, _point p2);
	time_t GetCurShiftStartTime(int& shift_id);
	time_t GetCurShiftEndTime();
	time_t GetLastShiftStartTime(int& shift_id);
	int GetCurShiftId(struct tm* current_time, int shift_type = 1);

	DIRECTION_TYPE GetDirectionType(_point card_point, _point landmark_point, int map_id);
	POS_DEVICE_TYPE GetPosDownAndUp(int vehicle_type_id, int area_id);
public:
	//Ժ
	void TestReadFile(); // distļжȡϢ
	int  ReadTofDistFile();			// TOFļжȡݣ
	int  TestGenerateAllDataJson(); // Ե¼ݽӿ
	void TestLandmarkRequirement(); // ԵرϢ
	void TestCallCard(); // Ժнӿڣվ
	void TestParseCallCard(); // Ժнӿڣǰָ
	void TestFitData(); // 
	void TestMultSql(); // д
	void TestCardPosition(); // Կʻ
	string get_json_call_test(); 
	void package_data_test();
public:
	std::unique_ptr<client> _io;
	CListBox m_list_log;
	CReportCtrl m_listctrl_reader;

	void OnPushMessage();
	void OnCallMessage(string const& name, message::ptr const& data, bool isAck,message::list &ack_resp); 
	void OnLogin(string const& name, message::ptr const& data, bool isAck, message::list &ack_resp);

	void OnConnected();
	void OnClosed(client::close_reason const& reason);
	void OnFailed();

	// Web
	std::unique_ptr<client> _io_ex;
	void OnLoginEx(string const& name, message::ptr const& data, bool isAck, message::list &ack_resp);
	void OnConnectedEx();
	void OnClosedEx(client::close_reason const& reason);
	void OnFailedEx();
protected:
	afx_msg LRESULT OnRemoveSocket(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnMsgRefreshIpList(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWriteErrorLog(WPARAM wParam, LPARAM lParam);
public:
	UINT m_reader_id_hist;
	afx_msg void OnEnUpdateEditReaderid();
	afx_msg void OnAbout();
	afx_msg void OnBnTest();

public:
	//㷨
	std::shared_ptr<CellPathMap> mpCellPath;
	CWinThread* pCellThread;			//500ms߳
	CWinThread* pSendCellThread;		//͸ݵ߳
	HANDLE hEvent;						//߳¼
	bool bSend;

	int init_cell_path_map();
	int SaveCellData2DB();
	int ModifyCardInfo();
	int DivideCell(double width, std::shared_ptr<TDOAReaderPathMap> pTdoaReaderPathMap);
	int InitCellBranch();
};

typedef struct {
	CYAServerDlg* handle;
	int len;
	DWORD dwConnID;
	BYTE buf[LENGTH_MSG_4K];
}ParseData;

typedef struct 
{
	CYAServerDlg* handle;
	bool useTime;
	char* path;
	char* strLog;
}LogInfo;