#ifndef YASERVER_CLASSDEF_H_
#define YASERVER_CLASSDEF_H_

#define MAX_DIST_CACHE 4  //5
#define DIST_COUNT 4
#define ANCHOR_COUNT 4

#define MINE_EVENT_COUNT 3
#define SECTION_EVENT_COUNT 6
#define AREA_EVENT_COUNT 5
#define CARD_EVENT_COUNT 30
#define READER_EVENT_COUNT 12

#define KALMAN_OFFSET_COOR 0.01
#define KALMAN_OFFSET_MOVE 1
#define KALMAN_OFFSET_RANGING 0.01
#define KALMAN_INTERVAL 0.3

#define KALMAN_OFFSET_COOR_TRI 0.01
#define KALMAN_OFFSET_MOVE_TRI 1
#define KALMAN_OFFSET_RANGING_TRI 0.09
#define KALMAN_INTERVAL_TRI 1

#define ANTENNA_COUNT 2
#define ADHOC_COUNT 10
#define READER_TIMEOUT 20
#define CARD_LOST_TIME_OUT 30 // (30 * 60)
#define CARD_LOST_TIME_OUT_SPECIAL_AREA 1800
#define READER_SEND_STATE_TIMEOUT 30 // (2* 60 * 60)
#define OVER_TIME (480 * 60)
#define MAX_SEMACOUNT 64

//㷨
//#define ALGORITHM_TYPE_TOF
//#define ALGORITHM_TYPE_TDOA
//#define ALGORITHM_TYPE_INS		//ʹùߵж
#define ENABLE_MY_LOG

#define NEED_DISPLAY_RULES 1  // lemon 2017/08/01
#define NEED_DISPLAY_VALID 0
#define NEED_DISPLAY_INVALID 1
#define PATROL_LEVEL_ID 3

#define INDEXFORRECONEREADER 10

#include <string>
#include <ctime>
#include <map>
#include <iostream>  
#include <string>  
#include <vector>
#include <unordered_map>
#include <deque>
#include <mutex>
#include <thread>
//#include "winsock2.h"
#include <kalman\locate.h>
#include "Filter\KalmanFilter.h"
#include "algorithm\FittingPosition.h"
#include "algorithm/cell/cell_struct.h"
#include "LocateRecord.h"

#define MIN(x,y) (x < y ? x : y)
#define MAX(x,y) (x > y ? x : y)

using namespace std;

//㷨ʹõĳ
const int MAX_CALC_POINTS = 30;
const double INS_WEIGHT = 9.0;	//ߵȨ
const double UWB_WEIGHT = 1.0;  //UWBȨ
const double MAX_VECHILE_SPEED = 30.0;	//25
const double NEAR_READER = 4.0;
const double MIN_DIFFER_DISTANCE = 10.0; // ʹվУʱжϸýУվľķΧ
const double VECHILE_ACCELERATE_THRESHOLD = 10; // Уٶֵ
const double PERSON_ACCELERATE_THRESHOLD = 10; // Уٶֵ
const int ACCELERATE_INIT_STATE = -10;
const double INVALID_COORDINATE = -1000.0;

const double CHAMBER_WIDTH = 3.0;			//ָǰչĿȣλΪ
const double VEHICLE_WIDTH = 10.0;
const int MAX_READER_TDOA_PATH_NUMS = 10;	//ҪΪ䴦ܴڶԭ
const int LIGHT_CTRL_DELAY = 1000;
const int MAX_REBOUND_COUNTS = 5;

const double TOF_HEIGHT_ERROR = 2;	//tofλʱĸ߶λΪ
const double READER_SYNC_INTERVAL_TIME  = 0.2;		//վͬŵʱֵ

#define OFFSET_THRE_IN_LINE 1	//жǷ߶ϣΪ1ףisinline
#define ZERO_PRECISION 1E-3		//Ϊľ
#define MAX_REBOUND_COUNTS 5

enum ALARM_FLAG{
	//AF_CARD_OVER_COUNT = 1,
	//AF_CARD_AREA_OVER_COUNT,
	AF_CARD_OVER_TIME,
	AF_CARD_OVER_SPEED,
	AF_CARD_AREA_OVER_SPEED,
	AF_CARD_AREA_OVER_TIME,
	AF_CARD_LOW_POWER,
	AF_CARD_LOW_POWER_SERIOUS,
	AF_CARD_AREA_FORBIDDEN,
	AF_AREA_OVER_COUNT,
	AF_AREA_OVER_TIME,
	AF_AREA_FORBIDDEN,
	AF_CARD_OVER_COUNT,
	AF_CARD_NEAR_WARNING_POINT,//lemon	
	AF_CARD_NEAR_DRRIVINGFACE_VEHICLE //lemon 2017/08/01
};

enum AREA_TYPE
{
	AREA_TYPE_FORBIDDEN = 3,	// 
	AREA_TYPE_NO_COVER = 1000,	// Ǹ򣬳źʧ󣬶λǸ
	AREA_TYPE_SPECIAL = 1001	// ֻǰʶǷʾͼ,ֳ
};

enum EDIT_TYPE_ID{
	ET_INSERT = 0, // 
	ET_UPDATE,	   // ޸
	ET_DELETE      // ɾ
};
//
enum VECHILE_TYPE_ID
{
	VT_DIGGINGCOAL_MACHINE=25,
	VT_DRIVINGFACE_MACHINE=26
};
enum ALARM_TYPE_ID
{
	ATID_OVER_COUNT_PERSON = 1,
	ATID_POWER,
	ATID_OVER_COUNT_VEHICLE
};

enum STATUS_DEVICE{
	STATUS_DEVICE_NORMAL = 0,
	STATUS_DEVICE_ERROR
};

enum STATUS_CARD
{
	STATUS_NORMAL = 0,				//
	STATUS_ERROR = 1, 
	STATUS_ERROR_SERIOUS = 2,

	STATUS_POWER_LOWER = 1,			//
	STATUS_POWER_LOWER_SERIOUS = 2, //
	STATUS_OVER_TIME = 4,			//ʱ
	//STATUS_OVER_COUNT = 1,
	STATUS_OVER_SPEED = 8,			//
	STATUS_AREA_OVER_TIME = 16,		//ʱ
	//STATUS_AREA_OVER_COUNT = 1,
	STATUS_AREA_OVER_SPEED = 32,	//
	STATUS_AREA_FORBIDDEN = 64,		//
	STATUS_HELP = 128,				//
	STATUS_HELP_DEALED = 256,		//
	STATUS_CALL = 512,				//
	STATUS_LOST = 1024				//ä
	//STATUS_ERROR_DEALED,
};

enum STORE_CARD_DATA_FLAG{
	HIS_LOCATION = 0,
	HIS_RAW_DATA,
	HIS_AREA_LOCATION_ENTER,
	HIS_AREA_LOCATION_LEAVE,
	RPT_ATTEND_DOWN,
	RPT_ATTEND_UP
};

enum STORE_MINE_DATA_FLAG{
	ALARM_MINE_OVER_COUNT_PERSON_START = 0,
	ALARM_MINE_OVER_COUNT_PERSON_END,
	ALARM_MINE_OVER_COUNT_VEHICLE_START,
	ALARM_MINE_OVER_COUNT_VEHICLE_END
};

enum STORE_LIGHT_DATA_FLAG{
	ALARM_LIGHT_FAULT_START= 0, 	//Ͽʼ
	ALARM_LIGHT_FAULT_END,			//Ͻ
	ALARM_LIGHT_NETWORK_START,		//Ͽʼ
	ALARM_LIGHT_NETWORK_END,		//Ͻ
	ALARM_LIGHT_CONTROL_FAILE		//ʧ
};

enum STORE_SECTION_DATA_FLAG{
	ALARM_SECTION_START = 0, // θ澯ʼ
	ALARM_SECTION_END // θ澯
};

enum LIGHT_STATE{
	LIGHT_NORMAL = 0, // 
	LIGHT_FAULT, // 쳣
	LIGHT_NETWORK_ERROR,  // 
	LIGHT_CONTROL_ERROR   // ʧ
};

enum LOCATE_TYPE
{
	LT_COORDINATE = 0, // ʹ궨λ
	LT_READER // ʹ÷վλ
};

enum FILTER_TYPE{
	NO_FILTER = 0,		// ʹ˲
	FILTER_KALMAN = 1	// ʹkalman˲
};

enum SECTION_STATE{
	SECTION_STATE_NORMAL = 0,		//
	SECTION_STATE_BUSY = 1,			//æ
	SECTION_STATE_CONGESTION = 2	//ӵ
};

enum LIGHT_SHAPE{
	RED_CIRCLE_SOLID = 1,	//ɫʵԲ
	RED_CIRCLE = 2,			//ɫԲ
	RED_CROSS = 3,			//ɫ
	GREEN_UP = 4,			//ɫϼͷ
	GREEN_DOWN = 5,			//ɫ¼ͷ
	GREEN_LEFT = 6,			//ɫͷ
	GREEN_RIGHT = 7,		//ɫҼͷ
	RED_SPARK = 8,			//ɫ˸
	GREEN_SPARK = 9			//ɫ˸
};

enum LIGHT_STREAM{
	INIT_STREAM = 0,
	UP_STREAM = 1,		//
	DOWN_STREAM = 2	//
};

enum LIGHT_COLOR{
	COLOR_RED = 1, // ɫ
	COLOR_GREEN = 2 // ɫ
};

enum LIGHT_CTRL_STATE{
	CTRL_STATE_AUTO = 1, //  Զ
	CTRL_STATE_MANUAL = 2 // ֶ
};

enum LIGHTS_SELECT_TYPE
{
	LST_ALL_LIGHTS = 0, // е
	LST_ALL_UP_LIGHTS = 1, // 
	LST_ALL_DWON_LIGHTS = 2,// 
	LST_SOME_LIGHTS = 3 // ָ
};

enum AREA_PROPERTY{
	MAIN_TUNNEL = 0, // 
	BRANCH_TUNNEL = 1 // ֧
};

enum OUTPUT_POS{
	CENTRAL_POS = 0, // 
	LEFT_POS,  // 
	RIGHT_POS  // 
};

enum PATROL_STATE
{
	PS_NORMAL = 0, // 
	PS_EARLY, // 絽
	PS_LATE,  // ٵ
	PS_NON_ARRIVAL // δ
};

enum PATROL_STAY_STATE
{
	PSS_NORMAL = 0, // 
	PSS_TOO_LONG,   // ͣ
	PSS_TOO_SHORT   // ̫ͣ
};

enum ALGO_LOC_TYPE{
	ALGO_LOC_SUCCESSED = 0,			//㷨λɹ
	ALGO_FAILED_CONDITION_1,		//ͬ5
	ALGO_FAILED_CONDITION_2,		//ͬкţʱͬȴ5
	ALGO_FAILED_CONDITION_3,		//ʱֵͬ쳣
	ALGO_FAILED_CONDITION_4,		//ϴʱڿıʱ
	ALGO_FAILED_CONDITION_5,		//˿ٶȳ
	ALGO_FAILED_CONDITION_6,		//ٶȳ
	ALGO_FAILED_CONDITION_7,		//ٶȳ
	ALGO_FAILED_CONDITION_8,		//2sλʧܵ
	ALGO_FAILED_CONDITION_9,		//վʱľֵڷվ֮ľ
	ALGO_FAILED_CONDITION_10,		//վ֮޵ͼ
	ALGO_FAILED_CONDITION_11,		//λ޽orĸΪ0
	ALGO_FAILED_CONDITION_12,		//վС4mվվ
	ALGO_FAILED_CONDITION_13,		//޵ͼվ֮ľ10m
	ALGO_FAILED_CONDITION_14,		//λ붨λվ֮ľ4
	ALGO_FAILED_CONDITION_15,		//붨λС2
	ALGO_LOC_TOTAL
};

enum ALGO_RETURN_VALUE{
	DIST_COUNT_LESS_THAN_TWO = 10001,
	DIST_COUNT_LESS_FOR_TIMESTAMP_ERROR,
	DIST_COUNT_LESS_FOR_SYNC_NUM_DIFFER_FIVE,
	DIST_COUNT_CARD_CUR_CT_LESS_LAST,

	ALGO_CALC_SOLUTION = 30001,
	ALGO_CALC_NO_SOLUTION_WITH_TWO_DATA,
	ALGO_CALC_ONE_DATA,

	SOLUTION_NO_SOLUTION = 40001,
	SOLUTION_NOT_EXIST_READRE,
	SOLUTION_NEAR_READER,
	SOLUTION_TWO_SOLUTION,
	SOLUTION_ERROR_STREAM,
	POSITION_INVALID,

	CHECK_PERSON_ACCE_OVER_SPEED = 50001,
	CHECK_VEHICLE_ACCE_OVER_SPEED,
	CHECK_VEHICLE_OVER_SPEED,

	KALMAN_FILTER_LONG_INTERVAL = 60001,

	ALGO_USE_KALMAN_FILTER = 70001,
	ALGO_DIVIDE_ZERO = 80001,
};

extern unsigned int g_nAlgoFailedCounts[ALGO_LOC_TOTAL];	//ȫֵͳд
extern unsigned int g_nAlgoFailedCycleCounts[ALGO_LOC_TOTAL];	//ָڵͳƴ
extern DWORD g_ullCurTime;

#define ALGORITHM_FAILED(nType) { \
	g_nAlgoFailedCounts[nType]++; \
}

struct AlgoFailedMsg{
	std::string strCardId;
	int nCardStamp;
	int nType;
	SYSTEMTIME st;
	bool bStatus;

	AlgoFailedMsg(){
		strCardId = "";
		nCardStamp = 0;
		nType = 0;
		bStatus = false;
	}
};

enum DEVICE_TYPE{
	DT_CARD_READER = 0, //վ
	DT_CTRL_READER = 1, // Ʒվ
	DT_LIGHT = 3, // ̵
	DT_SPEAKER = 4, // 澯
	DT_TURNOUT = 5, // 
	DT_LED = 6 // ʾ
};

enum CALL_STATE{
	CALL_NONE = 0,			//޺Ϣ
	CALL_SUCCESSED = 1,		//гɹ
	CALL_ING = 2,			//
	CALL_FAILED = 3,		//ʧ
};

enum LOCATEDATATYPE // λ
{
	LDT_TOF = 0, 
	LDT_TDOA
};
struct SQLTHREAD_DATA//дݿ̴߳ݵĲ
{
	char* pText;//ݿַָ
	int nRepeatTimes;//ѾԼ
};

// λ
struct _coordinate{
	_coordinate(){
		t = 0;
		reader_id = 0;
		tt = 0;
		d = 0.0;
		sync_num = 0;	

		x = 0.0;
		y = 0.0;
		z = 0.0;
		a = 0.0;
		v = 0.0;
		antenna_id = 0;
		d_offset = 0.0;
		special = 0;
		acceleration = 0;
		acce_state = 0;	
		acce_state_last = 0;
		ins_direction = 0;
		rangingtype = 1; // 0 tof1 toda
	}
	int t; // λʱ
	int reader_id; // վ
	unsigned long long syncRootId; // tdoaڵ
	unsigned long long tt; // վյʱ䣬ΪͬԲֵʱ
	double d; // 

	double x; // x
	double y; // y
	double z; // z
	double a; // ƽǶ
	double v; // ٶ
	int antenna_id;
	double d_offset; // ʾƫƣվ

	int sync_num;   //ͬ
	double acceleration;	//ٶ
	int acce_state;	//ٶ״̬
	int acce_state_last;	//ٶȼһ״̬
	int ins_direction;		//ߵ
	int special; //վǷվ0վ1ͨվ

	int rangingtype;

	int reason;

	_coordinate& operator=(_coordinate &tmp){
		t = tmp.t;
		reader_id = tmp.reader_id;
		tt = tmp.tt;
		d = tmp.d;
		sync_num = tmp.sync_num;
		x = tmp.x;
		y = tmp.y;
		z = tmp.z;
		a = tmp.a;
		v = tmp.v;
		antenna_id = tmp.antenna_id;
		d_offset = tmp.d_offset;
		special = tmp.special;
		acceleration = tmp.acceleration;
		acce_state = tmp.acce_state;
		acce_state_last = tmp.acce_state_last;
		ins_direction = tmp.ins_direction;
		rangingtype = tmp.rangingtype;
		reason = ALGO_LOC_SUCCESSED;
		return *this;
	}
};

struct _point{ // 
	double x;
	double y;
	double z;

	_point(){
		x = y = z = 0;
	}

	_point(double a,double b,double c){
		x = a;
		y = b;
		z = c;
	}
};

struct sync_data{
	double x;
	double y;

	double vx;
	double vy;

	int sync_num;	//ͬ
	bool update;

	std::shared_ptr<nspLocate::LocateRecord> locate;

	sync_data(){
		x = 0.0;
		y = 0.0;
		vx = 0.0;
		vy = 0.0;
		sync_num = 0;
		update = false;
		locate = nullptr;
	}

	sync_data& operator=(sync_data&tmp){
		x = tmp.x;
		y = tmp.y;
		vx = tmp.vx;
		vy = tmp.vy;
		sync_num = tmp.sync_num;
		update = tmp.update;
		locate = tmp.locate;
		return *this;
	}
};

struct _call_info_card
{
	int card_id;
	int card_type;
	int call_type;
	string str_card_id;
	time_t start_time;
	int time_out;
	//bool is_success;
	int call_state;
};
//typedef map<std::string, _call_info_card*> CallInfoCardMap;
typedef map<std::string, std::shared_ptr<_call_info_card>> CallInfoCardMap;

struct _call_info_reader
{
	bool is_call_all;
	bool is_start_call;		//true,ʼ;false,ȡ
	BYTE call_type;
	int cards_count;
	CallInfoCardMap mpCard;
};

typedef map<int, std::shared_ptr<_call_info_reader>> CallInfoReaderMap;

struct _call_info_user
{
	std::string user_name;
	CallInfoReaderMap mpReader;
};
typedef map<string, std::shared_ptr<_call_info_user>> CallInfoUserMap;

// վʱ䶨
struct ReceiveData{
	unsigned int reader_id;		// վ
	unsigned short antenna_id;  // ߺ
	long long rec_time_stamp;	// վʱ䣬һ5ֽڵ޷
	int special;
	double x;	//վx
	double y;   //վy
	double z;   //վz
	ReceiveData(){
		reader_id = -1;
		antenna_id = -1;
		rec_time_stamp = 0;
		x = y = z = 0.0;
		special = -1;
	};
};

struct INFO_PRE{
	int t;
	long long detaT;
	double dist;
	int ant;
	int sta_num;
};

struct TOF_REFER_DATA{
	unsigned int nCardTimeStamp;	// ct
	long long llDeltaTime;			// 
	double dDistance;				// 
	unsigned int nAntennaIndex;		// վ
	unsigned int nReaderId;			// վid
	double x;						// οx
	double y;						// οy
	double z;						// οz
	int a;							// ٶ״̬

	TOF_REFER_DATA(){
		nCardTimeStamp = 0;
		llDeltaTime = 0;
		dDistance = 0.0;
		nAntennaIndex = nReaderId = 0;
		x = y = z = 0.0;
		a = 0;
	}
};

struct POS{
	double posx;
	double posy;
	double posz;
	double pos_radius;

	double cx;
	double cy;
	double cz;
	//ٶ
	double cvx;
	double cvy;
	double cvz;
	//ٶ
	double av;

	//涨λվϢ
	int nFirstReader;
	int nSecondReader;

	//Ȳο
	double dDiff[MAX_READER_TDOA_PATH_NUMS];
	double dis_diff;

	int reason;
	int status;
	int card_count;	//ct
	bool update;
	bool is_back;
	bool is_fit;

	//ǰվͬοݵķվͬʱֵ
	double diff_reader_sync_num;

	double delta_time;			//ʱ
	//οݵĶλ
	double ref_x;
	double ref_y;
	double ref_z;
	double origin_speed;	//ԭʼλٶ

	double sumVariance; // λֵ֮ĺ

	POS(){
		nFirstReader = 0;
		nSecondReader = 0;
		pos_radius = 999999.9;	
		posx = posy = posz = INVALID_COORDINATE;
		cx = cy = cz = cvx = cvy = cvz = 0.0;
		av = 0.0;
		status = 0;

		for (int i=0;i<MAX_READER_TDOA_PATH_NUMS;i++)
		{
			dDiff[i] = 0;
		}

		dis_diff = 999999.9;
		update = false;
		is_fit = false;
		is_back = false;
		origin_speed = 0;
		sumVariance = 0;
		diff_reader_sync_num = 0;
		delta_time = 0.0;
		ref_x = ref_y = ref_z = 0;
		reason = -1;
		reason = ALGO_LOC_SUCCESSED;
	}

	POS& operator=(POS& tmp){
		nFirstReader = tmp.nFirstReader;
		nSecondReader = tmp.nSecondReader;
		posx = tmp.posx;
		posy = tmp.posy;
		posz = tmp.posz;
		cx = tmp.cx;
		cy = tmp.cy;
		cz = tmp.cz;
		cvx = tmp.cvx;
		cvy = tmp.cvy;
		cvz = tmp.cvz;
		av = tmp.av;
		update = tmp.update;
		origin_speed = tmp.origin_speed;
		status = tmp.status;
		is_back = tmp.is_back;
		diff_reader_sync_num = tmp.diff_reader_sync_num;
		delta_time = tmp.delta_time;
		dis_diff = tmp.dis_diff;
		ref_x = tmp.ref_x;
		ref_y = tmp.ref_y;
		ref_z = tmp.ref_z;
		sumVariance = tmp.sumVariance;
		for (int i=0;i<MAX_READER_TDOA_PATH_NUMS;i++)
		{
			dDiff[i] = tmp.dDiff[i];
		}
		pos_radius = tmp.pos_radius;
		reason = ALGO_LOC_SUCCESSED;

		return *this;
	}
};

//Ľṹ
struct SOLUTION{
	double x[3];
	double y[3];
	double z[3];
	int nCount;

	SOLUTION(){
		for (int i =0;i<3;i++)
		{
			x[i] = y[i] = z[i] = INVALID_COORDINATE;
			nCount = 0;
		}
	}
};

class Mine;
class Area;
class SpecialAreaEntry;
class DrivingfaceRender;
class DrivingfaceCard;
class DrivingfaceWarningPoint;
class VehicleTypeAttRule;
class Reader;
class Card;
class MapInfo;
class Dept;
class BanShift;
class OccLevel;
class ReaderPath;
class PatrolPoint;
class PatrolTask;
class LeaderArrange;

class Section;
class Chamber;
class Light;
class LightsGroup;
class LightCallInfo;
class StorePostion;

class LandmarkInfo;
class MapDirectionInfo;

typedef map<string, std::shared_ptr<Card>> CardMap;
typedef map<int, std::shared_ptr<Area>> AreaMap;
typedef map<int, std::shared_ptr<DrivingfaceWarningPoint>>DrivingfaceWarningPointMap;
typedef map<int,std::vector<std::shared_ptr<DrivingfaceWarningPoint>>> DrivingfaceWarningPointMapAll;
typedef map<int, std::shared_ptr<SpecialAreaEntry>> SpecilaAreaEntryMap;
typedef map<int, std::shared_ptr<DrivingfaceRender>> DrivingfaceRenderMap;
typedef map<string,std::shared_ptr<DrivingfaceCard>> DrivingfaceCardMap;
typedef map<int, std::shared_ptr<Reader>> ReaderMap;
typedef map<int, std::shared_ptr<MapInfo>> MapInfoMap;
typedef map<int, std::shared_ptr<MapDirectionInfo>>MapDirectionInfoMap;
typedef map<int, std::shared_ptr<LandmarkInfo>>LandmarkInfoMap;
typedef map<int, std::shared_ptr<Dept>> DeptMap;
typedef map<int, std::shared_ptr<BanShift>> BanShiftMap;
typedef map<int, std::shared_ptr<OccLevel>> OccLevelMap;
typedef map<int, string> AlarmTypeMap;
typedef map<int,std::shared_ptr<ReaderPath>> ReaderPathMap;
typedef map<int,std::shared_ptr<ReaderPath>> TOFReaderPathMap;
typedef unordered_map<int,std::shared_ptr<ReaderPathMap>> TDOAReaderPathMap;
typedef unordered_map<std::string, std::shared_ptr<_coordinate>> DistMap;
typedef map<unsigned long long ,std::shared_ptr<ReceiveData>> ReceiveDataMap;
typedef map<int,std::shared_ptr<Section>> SectionMap;	//·Ϣ
typedef map<int,std::shared_ptr<Chamber>> ChamberMap;	//Ϣ
typedef map<int,std::shared_ptr<Light>> LightMap;		//̵Ϣ
typedef map<int,std::shared_ptr<LightsGroup>> LightGroupMap;	//̵Ϣ
typedef map<unsigned int, std::shared_ptr<PatrolPoint>> PatrolPointMap;
typedef map<unsigned int, std::shared_ptr<PatrolTask>> PatrolTaskMap;
typedef map<std::string, std::shared_ptr<PatrolTask>> PatrolTaskCheckMap;
typedef map<unsigned int, std::shared_ptr<PatrolPoint>> PatrolPointMap;
typedef map<unsigned int, std::shared_ptr<PatrolTask>> PatrolTaskMap;
typedef map<std::string, std::shared_ptr<PatrolTask>> PatrolTaskCheckMap;
typedef deque<std::shared_ptr<StorePostion>> QueStrorePos;
typedef map<std::string, std::shared_ptr<LeaderArrange>> LeaderArrangeMap;
typedef map<int,string> WorkTypePermissionMap;
typedef map<int,int> RulesMap; //lemon 2017/08/01
typedef map<int, std::shared_ptr<VehicleTypeAttRule>> VehicleTypeAttRuleMap;

typedef std::map<std::string,std::list<std::shared_ptr<Cell>>> CellPathMap;

typedef struct key_value_pair
{
	int key;
	int value;
	struct key_value_pair* next;
}KeyValuePair;

typedef struct statistic_data_str
{
	int index;
	KeyValuePair* data_info;
	struct statistic_data_str* next;
}StatisticDataStr;

struct DistQueMapItem
{
	WORD cardstamp;
	DistMap distmap;
};
typedef deque<DistQueMapItem> DistQueMap;

// ͼ
class MapInfo{
public:
	MapInfo(void);
	~MapInfo(void);
public:
	int map_id;
	string map_path;
	string map_name;
	double map_width;
	double map_height;
	double map_scale;
	int map_type;

	AreaMap map_area_list;
	ReaderMap map_reader_list;
	ReaderMap map_ctrl_reader_list;
	CardMap map_card_list_person;
	CardMap map_card_list_vehicle;
	ChamberMap map_chamber_list;
	SectionMap map_section_list;
	LightMap map_light_list;
	LightGroupMap map_light_group_list;
};

class LandmarkInfo
{
public:
	int landmark_id;
	string landmark_name;
	int map_id;
	double x;
	double y;
	double z;
};

class MapDirectionInfo
{
public:
	int map_direction_id;
	int map_id;
	int north_angle;
};
// 
class Area  // 
{
private:
	std::vector<std::string> split(std::string str,std::string pattern);
	double get_vertex(std::string src); // 
public:
	Area(void);
	~Area(void);
	void init_border(string sz_path);
	bool is_in_polygon(_point p);
	int is_special(); // ǷΪ
public:
	int map_id;
	int area_id;
	string area_name;
	string area_type_name;
	string path; // 
	int area_type_id;
	// Ա
	int over_count_person;
	int over_time_person;
	int under_count_person;
	int under_time_person;
	// 
	int over_count_vehicle;
	int over_time_vehicle;
	int under_count_vehicle;
	int under_time_vehicle;
	double over_speed_vehicle;		//ٶֵ

	int polygon_count;
	_point* polygon;

	double rect_left;
	double rect_right;
	double rect_top;
	double rect_bottom;

	// 
	int count_person;
	int count_vehicle;
	int count_card;

	// Ƿд
	int is_att; // 0 ͣ⣬1 ͣ
	bool is_area_over_time_person; // ʱ
	bool is_area_over_time_vehicle; // Աʱ
	int count_area_over_time_person; // ʱ
	int count_area_over_time_vehicle; // ʱ
	time_t time_over_time_person; // ʼʱʱ
	time_t time_over_time_vehicle; // ʼʱʱ

	bool is_area_over_count_person; // ԱԱ
	bool is_area_over_count_vehicle; // Ա
	int count_area_over_count_person;
	int count_area_over_count_vehicle;
	time_t time_over_count_person; // ʼʱ
	time_t time_over_count_vehicle; // ʼʱ

	bool is_area_forbidden_person;
	bool is_area_forbidden_vehicle;
	int count_area_forbidden_person;
	int count_area_forbidden_vehicle;
	time_t time_forbidden_person; // ʼʱ
	time_t time_forbidden_vehicle; // ʼʱ

	std::shared_ptr<CardMap> area_card_list_person;
	std::shared_ptr<CardMap> area_card_list_vehicle;
	std::shared_ptr<CardMap> area_card_list_over_speed;

	INT64 m_event_list[AREA_EVENT_COUNT]; // ¼Id
};

class DrivingfaceWarningPoint
{
public:
	int warning_point_id;
	string warning_point_name;
	int driving_face_id;
	float point_x;
	float point_y;
	float point_z;
	float warning_threshold;
	int is_valid;
};
class SpecialAreaEntry
{
public:
	SpecialAreaEntry(){}
public:
	double start_point_x;
	double start_point_y;
	double start_point_z;
	double end_point_x;
	double end_point_y;
	double end_point_z;
	int    special_area_id;
};

class DrivingfaceRender
{
public:
	DrivingfaceRender(){}
public:
	INT    drivingface_id;
	INT    reader_id;
	double vertical_distance;
	double x;
	double y;
	double z;
};

// 뿨Ϣ
class DrivingfaceCard
{
public:
	double x;
	double y;
	double z;
	INT drivingface_id;
	string card_id;
	INT area_id;
	float warning_threshold;
};

// Ԥ
class Adhoc
{
public:
	Adhoc();
	~Adhoc();
public:
	int adhoc_id;
	double x;
	double y;
	double z;
	int idx;
};

// 
class Antenna
{
public:
	Antenna(void);
	~Antenna(void);
public:
	int antenna_id;
	double antenna_x;
	double antenna_y;
	double antenna_z;
	double antenna_angle;
};

// վ
class Reader
{
public:
	Reader(void);
	~Reader(void);
public:
	int reader_id; // վ
	string reader_name; // վ
	int device_type_id;
	int pos_state; // λ״̬ 1ϣ2
	string ip;
	double reader_x; 
	double reader_y;
	double reader_z;
	double reader_angle;

	double reader_interval_time;

	int map_id; // ڵͼ
	int area_id; // 
	double map_scale; // 

	time_t rec_time; 
	time_t reader_time; // վʱ
	time_t lost_time;
	time_t last_send_time; // ǰ˷ʱ
	int temperature; // ¶
	int tick_count; // 
	int reader_state; // ״̬ 0 , 1 
	int reader_state_old; 

	int sync_level;
	unsigned long long sync_rootId;

	std::shared_ptr<Antenna> ant[ANTENNA_COUNT];
	std::shared_ptr<Adhoc>   adhoc[ADHOC_COUNT];
	map<int,_point> readerCoveragePath;
	bool bIsInitCoverage;
	int m_nIsSpecial;
	bool init_ctrl_reader_state;	//ΪƷվʱһҪô˿Ʒվµĺ̵״̬

	INT64 m_event_list[READER_EVENT_COUNT]; // ¼Id
public:
	string get_state_text();
};

class StorePostion
{
public:
	StorePostion(){
		x = y = z = 0;
		GetLocalTime(&save_time);
	};
	~StorePostion();

	double x, y, z;
	SYSTEMTIME save_time;
};

// 
class Card
{
public:
	Card(void);
	~Card(void);
	Card(string cardid, int cardtype,double z_offset);

public:
	CRITICAL_SECTION m_csCard;
	bool is_registered;
public:
	int card_type; //  0x01, 0x02
	string card_id;

	// Ա
	int level_id;
	int worktype_id;// lemon 2017/07/31 Ϊvehicle_type_id
	int vehice_type_id;
	// Ա
	int id; // ţԱ
	int dept_id; // 
	int occlevel_id; // ְid
	int group_id; // 	
	int need_display;// lemon 2071/08/01 ǷWebʾ
	int shift_type_id; // Աִ߳еİ

	string driver_id;	//ǳ˾id
	int light_id; // ƵĵƱ
	int shift_id;
	SYSTEMTIME deal_time; // ߼ʱ
	SYSTEMTIME enter_area_time;
	//
	int m_indexForRcvOneReader;
	//driving face write database time
	ULONGLONG drive_face_location_write_time;
	ULONGLONG drive_face_location_end_time;
	//SYSTEMTIME down_time;
	time_t rec_time; // ʱ
	time_t down_time; // 뾮ʱ
	time_t up_time; // ʱ
	time_t enter_reader_time; // վʱ
	time_t low_power_time; // Ϳʼʱ
	double coor_offset_x;
	double coor_offset_y;
	double x;
	double y;
	double z;
	//鿴ǷΪʼֵǲв
	bool is_drivingface_Initialization;

	int driving_face_id;
	double driving_face_cur_shift_start_x; //cur shift start position
	double driving_face_cur_shift_start_y;
	double driving_face_cur_shift_start_z;

	double driving_face_cur_shift_x; //cur shift real point
	double driving_face_cur_shift_y;
	double driving_face_cur_shift_z;

	double drving_face_cur_shift_max_speed;

	double a; // ϴζλʱĽǶ
	int t; // ϴζλʱʱ

	double v; //ٶ
	double mileage; // ̣ϴαʱľ
	double z_offset;
	bool init_postion;
	bool is_first_location;
	int is_driving_face_start;

	double right_x,right_y,right_z;		//ֱָλұƫƵx,y,z
	double left_x,left_y,left_z;		//ֱָλƫƵx,y,z

	double last_x;
	double last_y;
	double last_z;

	double last_offset_x;
	double last_offset_y;

	double stored_x;
	double stored_y;
	double stored_z;

	double output_x;
	double output_y;

	double last_vx;
	double last_vy;

	int state;	// 0  32bit,ÿbitһ״̬:
	// һλ 0x01 ³ʱ, ڶλ 0x02 ʱ, λ 0x04 , λ 0x08, 
	// ״̬ϡ͵
	int state_moving; // ˶״̬ 0 ֹ1 

	// ͡ С
	int status_over_time; // 0 δʱ1 ʱ
	int status_over_speed; // 0 δ٣1 
	int status_area_over_time; // 0 δʱ 1 ʱ
	int status_area_over_speed; // 0 δ٣ 1 
	int status_area_forbidden; // 0 δ 1 
	int status_help; // 0 δȣ 1 ȣ 2 Ѵ
	int status_call; // 0 δ 1 
	int status_power; // 0 1 
	int status_lost; // 0 δä1 ä״̬

	int map_id; // ǰͼ
	double map_scale; // ͼ
	int map_id_old; // ϴβڵͼ
	int area_id; // ǰ	
	int landmark_id;
	double landmark_dis;
	int landmark_direction;
	int reader_id; // ǰվ

	Reader* p_reader;
	std::shared_ptr<ReaderPathMap> pTofReaderPathMap;
	std::shared_ptr<TDOAReaderPathMap> pTdoaReaderPathMap;
	map<unsigned long long,std::shared_ptr<_coordinate>> mp_dists_locate;
	_coordinate** p_dists_locate;
	_coordinate last_locate;
	_coordinate origin_locate;

	QueStrorePos _storepostions;	
	DistQueMap _dists;
	int time_stamp_max; // ʱҪ㶨λʱ
	int time_stamp_cal;

	int m_nFilterType;
	int m_nLastLocateT;
	int m_nCalcSyncNum;	//㷨еͬţͬźͿʵʱͬŲһһ
	int m_nSyncNumInList;	//ӶȡĴ5ͬ
	int m_nStream;			//С
	int m_nLightGroupId;
	int m_nMoveDirection;		//1Ϊ˶-1Ϊ˶
	int m_nIsRailroad;			//ǷΪй쳵0Ϊ޹쳵1Ϊй쳵
	int m_nOutputPosState;		//0Ϊм꣬1Ϊƫ꣬2Ϊƫ
	bool bIsBack;

	bool issent;		// true ѷͻˣfalse ݣҪͻ
	bool issaved;		//true ѱ浽ݿ⣬false µĿڼ¼Ҫ浽ݿ
	bool isdealed;		// Ѿ
	bool isreceive;		// յ
	bool is_pos_changed;
	bool is_deal_by_algo;		//Ƿ񾭹㷨
	bool is_hist;
	bool is_need_cal;

	bool m_bUseFilter;
	bool isoutput;				//Ƿjson
	bool is_red_light;

	bool is_mine_over_time;		// Ƿ³ʱ
	bool is_mine_over_speed;    // Ƿ³

	bool is_area_over_time;		// Ƿʱ, ʱֳʱԱʱ
	bool is_area_over_speed;	// Ƿ

	time_t time_area_over_time; // ʱʼʱ
	time_t time_over_time;		// ³ʱʼʱ
	time_t time_area_forbidden; // ʱ
	time_t time_over_speed;		// ٿʼʱ
	time_t time_area_over_speed;
	time_t time_low_power;

	time_t time_red_light;		//ʱ
	time_t last_locate_time;	// λʱ

	void reset();				// ״̬
	void set_reader(std::shared_ptr<Reader> preader);
	void add_dist(_coordinate* dist);
	void add_dist(std::shared_ptr<_coordinate> dist);
	void remove_dist_head();
	string concat(int reader_id, int ant_id);
	time_t get_working_time();
	string get_state_text();
	string get_acc_text();
	double get_speed();
	void set_speed(double v);
	int get_effictive_dist_count(int offset = 0);
	void set_reader_path(std::shared_ptr<ReaderPathMap> rpm, std::shared_ptr<TDOAReaderPathMap> trpm);
	void inspect_coordinate(int acce_state);
	bool checkStream(double x1,double y1,double x2,double y2,int nStream);

	int const PosState();
	void PosState(int val);
	void PosStateOld(int val);
	bool is_pos_state_changed(); // \״̬仯
	int const StateBiz();

	INT64 m_event_list[CARD_EVENT_COUNT]; // ¼Id
public://lemon
	int m_warning_point_id; 
	bool m_isWarning; // 0 
	double m_minDistanceToWarningpoint; //
	double m_warning_threshold; //limit value
	bool m_CardHasBeenInDrivingfaceAlarm;
	int m_DrivingfaceAlarmFlag;
	//lemon 2017/08/01
	inline double getDrivingfaceCulValue(){return m_drivingface_distance_cul_values;}
	inline double getDrivingfaceLimitValue(){return m_drivingface_distance_limit_values;}
	inline void	 setDrivingfaceCulValue(double cvalue){m_drivingface_distance_cul_values = cvalue;}
	inline void  setDrivingfaceLimitValue(double lvalue){m_drivingface_distance_limit_values = lvalue;}
private:
	double m_drivingface_distance_cul_values;
	double m_drivingface_distance_limit_values;
public:
	//㷨ز
	bool is_algo_first_location;		//ʾ㷨ĵһζλ

	std::shared_ptr<nspLocate::LocateRecord> locate;
	std::list<std::shared_ptr<POS>> idle_pos_list;

	void algo_tof(int cnt);
	int  algo_tof_1d(int cnt);		// tofһάλ
	void algo_tdoa(int cnt);

	int  algo_tdoa_1d(int cnt);		//һάλ
	int  algo_tdoa_2d(int cnt);		//άλ
	int  algo_tdoa_3d(int cnt);		//άλ

	void algo_calc_offset();		//ƫ
	double x_offset_after();        //ƫƺX
	double y_offset_after();        //ƫƺY
	double z_offset_after();        //ƫƺZ
	bool algo_is_same_direction(double x,double y,double z);	//˴η

	int CheckDistData(int cnt);
	int AssembleDistData(std::shared_ptr<ReceiveDataMap> pRdm);
	int SaveCardAlgoData(std::shared_ptr<POS>& pos);
	int SaveTofData(const std::shared_ptr<POS> pos);
	int SaveTdoaData(const std::shared_ptr<POS> pos);
	int SaveOriginDataBeforeFilter(std::shared_ptr<POS> pos);
	int ChooseOneSolution(std::shared_ptr<ReceiveDataMap> pRdm, std::vector<std::shared_ptr<POS>> udm_pos, std::shared_ptr<POS>& pos);// Ψһ

	int CheckSolution(std::shared_ptr<POS>& p);					// ֤ΨһϷԣٶȡٶ
	int CheckSulutionByStream(std::shared_ptr<POS> p);			// ʹ÷ã޸ֵ
	int GetStream(double x1,double y1,double x2,double y2);		// з
	int CalcPositionBySpeed(std::shared_ptr<POS>& pos,double v);
	bool CheckStreamUniformity(double x1,double y1,double x2,double y2,int nStream);
	bool IsExistPath(int left,int right);
	int CopySolution(std::shared_ptr<POS> source,std::shared_ptr<POS>& dest);
	//std::shared_ptr<nspLocate::LocateRecord> locate;
	int GetDeltaT(map<unsigned long long,std::shared_ptr<_coordinate>> dl);
	int CheckCardStatus();
	bool IsIdleStatus(std::shared_ptr<POS> pos);
	bool IsRebound(std::shared_ptr<POS> pos);		//жǷ
	bool CheckPositionValid(const std::shared_ptr<POS> pos);		//Ч

	double GetDeltaT();		//ȡʱֵ
public:
	//tofر
	time_t time_last_tof;

	bool CheckSolutionTof(std::shared_ptr<POS>& pos);		//ͨٶȼٶȼ鶨λǷȷ
private:
	void set_reader_path_tof(std::shared_ptr<ReaderPathMap> rpm);			// tof·
	void set_reader_path_tdoa(std::shared_ptr<TDOAReaderPathMap> trpm);		// tdoa·
public:
	// ˲㷨
	std::unique_ptr<CKalmanFilter> m_pKalmanFilter;		// ˲
	list<sync_data> m_syncNumList;
	std::list<std::shared_ptr<POS>> his_idle_pos;

	int last_s_locate_reader[2];	//һζλɹķվϢ

	double ins_weight;			//ٶȼ״̬Ȩ
	double uwb_weight;			//uwb״̬Ȩ
	int diff_direction_counts;

	int acce_cur_state;		//㷨б浱ǰٶ״ֵ̬ԭڶ߳accelerate_stateaccelerate_state_last״̬ܱ仯
	int acce_last_state;	//㷨бһμٶ״̬

	std::list<double> vt_his_speed;
	void get_coordinate();
	void get_coordinate(int cnt);
	void get_coordinate_3d(int cnt);
	void set_anchors(int cnt);

	void EnableFilter(int nType);
	int FindDistMap(int cardstamp);
	int KalmanFilterProcess(std::shared_ptr<POS>& pos);
	bool CheckCrossCycle();
	bool isRebound(std::shared_ptr<POS> pos);			//жǷ
public:
	bool b_save_pos;
	//ڳʱ޷λʹ㷨
	std::list<std::shared_ptr<POS>> his_pos;	//֮ǰ5Ϣ
	std::list<std::shared_ptr<Cell>> lvCells;	//϶Уڼֵ

	bool is_ref_pos;		//жǷΪο
	bool is_fit_pos;
	bool have_fit_pos;
	bool have_long_fit_pos;
	bool is_over_interval;		//ڱmodify_card_speedеǰʱͿʱǷ񳬹ָʱ״̬

	int count_idle;			//ͳжٴû仯ˣжϳǷ٣ͳ5
	int cur_fit_nums;		//ǰϴݷhis_pos
	int cur_ref_totals;
	int count_change_direction; // ͳƷıĵλ3Σıʻ

	double fitting_v[REF_POSITION_NUM];
	double fitting_ct[REF_POSITION_NUM];
	double fitting_x[REF_POSITION_NUM];
	double fitting_y[REF_POSITION_NUM];

	double fit_new_x[FIT_POSITION_NUM];
	double fit_new_y[FIT_POSITION_NUM];

	//ڶ
	std::list<std::shared_ptr<POS>> long_his_pos;	//֮ǰ20ϢϢUWBλϢ
	double long_fitting_ct[REF_POSITION_NUM];
	double long_fitting_x[REF_POSITION_NUM];
	double long_fitting_y[REF_POSITION_NUM];

	double long_fit_new_x[FIT_POSITION_NUM*4];
	double long_fit_new_y[FIT_POSITION_NUM*4];

	int UpdateFittingData(std::shared_ptr<POS> pos);	//ϻ
	int CalcFittingData();								//
	int CalcLongFittingData();
	int CalcFittingData(int ret,std::shared_ptr<POS>& pos);	
	int CalcLongFittingData(int ret,std::shared_ptr<POS>& pos);	
	int GetPosFromFittingData(std::shared_ptr<POS>& pos);
	std::shared_ptr<POS> GetPosFromFittingData();						//ݻȡλ
	int CheckSolutionByFit(int ret,std::shared_ptr<POS>& pos);
	int CheckSolutionBySpeed(std::shared_ptr<POS>& pos);

	bool CheckCardCtValid();	//鿨ctЧ

	double GetFittingDegree(std::list<std::shared_ptr<Cell>> ltCells);	//϶
private:
	bool b_long_interval;	//һζλļʱ10s

	int state_biz;		//ҵ״̬/ʱ/

	int pos_state;		// λ״̬0ʼ1£2ϣ3վ
	int pos_state_old;
	int pos_state_count;			// ǰλ״̬ȷϴ
	int pos_state_confirm_times;	// ¡״̬ȷϴĬΪ1

public: // ɼĵײ
	int time_stamp_last; // λʱ
	int context_type_last; //  toftdoa
	int accelerate_state_last; // һμٶ״̬
	int antenna_id_last; // ߺ
	double antenna_angle_last; // ߽Ƕ
	double distance_last; // 	
	int64_t flying_time_last; // ʱ
	int power_state_last; // 
	int ins_direction;	//һεĹߵϳɷ
	int direction;		//и
	int reader_id_last;	//һζλʱķվid
public:
	bool b_pos_change;		//λ÷˸ı
	bool b_enter_intersection;	//Ƿ·
public: // ɼĵײ
	int reader_tickcount; 
	int time_stamp; // λʱ
	int ranging_type; //  toftdoa
	int accelerate_state; // ٶ
	int antenna_id; // ߺ
	double antenna_angle; // ߽Ƕ
	double distance; // 
	int64_t flying_time; // ʱ
	int power_state; // 
	int sync_num;

	string str_his_time;
	string str_rec_time;
	//Ϣ
	int call_type;
	std::vector<int> vt_deal_call_reader_id;
	time_t recv_call_time;	//յеʱ

public:
	//Լͳƹ
	AlgoFailedMsg m_afmData;

public:
	//㷨Ĵ
	bool bInitalCellPath;
	bool isNeedWrited;

	std::shared_ptr<CellPathMap> mpCellPath;
	std::string curCellReaderName;		//ǰվ
	std::string originCellReaderName;	//ԭʼλվ
	ULONGLONG calc_cell_time;		//浱ǰλļʱͨݺͨ500ms䣩
	ULONGLONG data_cell_time;		//ͨݽжλ
	SYSTEMTIME cellDealTime;		//Ӵʱ

	int curCellId;			//ǰid
	int originCellId;		//ԭʼλid
	int nIncrease;			//Ƿ0ΪδʶΪ1½Ϊ-1
	int nStartLocateCounts;	//λͳƣǰ5ζλǷ٣٣˶˶ʼ
	int change_cell_dir;	//ıӷ
	int locateCounts;		//ͳƶλȡģ
	int isInsertToDb;		//ݿ
	int nOverThreCounts;	//

	double fit_k;	//µĸϵб
	double last_k;
	double delta_ct; //ctĲֵ
	double fit_b;	//µĸϵĽؾ
	double fit_r;	//бʱ϶
	double cell_a;	//㷨еļٶֵ

	bool isIdling;		//״̬

	std::thread* pThread;

	std::shared_ptr<Cell> last_cell;
	std::list<std::shared_ptr<Cell>> his_cell;
	std::list<std::shared_ptr<Cell>> locate_cells;

	int DiscreteLocate(int cnt);
	int PersonLocation(int cnt);
	bool CheckIdleStatus();
	bool CheckStartRule();
	bool isOverThreshold();
	bool isRebound(std::shared_ptr<Cell> cell);
	std::shared_ptr<Cell> Position2Cell(std::shared_ptr<POS> pos);		//תΪϢ
	std::shared_ptr<POS> Cell2Position(std::shared_ptr<Cell>& cell);	//Ϣת
	std::shared_ptr<Cell> GetNextCell(std::shared_ptr<Cell> lastCell,int increase,int nIndex);
	std::shared_ptr<Cell> GetNextCell(std::shared_ptr<Cell> lastCell,int increase,int nIndex,std::shared_ptr<Cell> newCell);
	std::shared_ptr<Cell> FindCell(std::string strReaderName,int cellid);

	int SetCellPathMap(std::shared_ptr<CellPathMap> pCellPath);
	int ChangeSystemTime(SYSTEMTIME& st,const int condition);
	int ChangeSystemTime(SYSTEMTIME& st);	//stϼ500ms
	int ChangeSystemTimeBySecond(SYSTEMTIME& st);	//1sķʽstʱ
	int colourfulCloudsChasingTheMoon(std::shared_ptr<Cell> &cell, std::list<std::shared_ptr<Cell>> &myCellList);
	int MappingCell2FitLinear(std::shared_ptr<Cell>& cell);		//ϵ
	bool cftool(float *data_x, float *data_y, int data_n, std::vector<float> &vResult);
	int SaveCardAlgoData(std::shared_ptr<Cell>& cell);

	//˼ƽ޶ĴPart 3/Sum 3:begin
	//ºǰʱ̵ĺΪ0ms500ms
	//by lsp on 2017.07.09 @ɽ
	int ChangeMsTimeToZeroOrFive(SYSTEMTIME& st);
	//˼ƽ޶ĴPart 3/Sum 3

	HWND pMainWnd;

	int SetMainHwnd(HWND hWnd){
		pMainWnd = hWnd;
		return 0;
	}
public:
	//Բغ
	int OutputCmdLog(int n);

	double dTestDelatT;		//ʱ
	double dTestDistance;		//εĶλľ
};

class BanShift
{
public: 
	BanShift();
	~BanShift();
	BanShift(int id, std::string s, std::string e, int tid);
	int shift_id;
	int shift_type_id;
	std::string start_time;
	std::string end_time;
};

class LeaderArrange
{
public:
	LeaderArrange( string cardid);
	~ LeaderArrange();

	int staff_id;
	string card_id;
	int shift_id;
	int shift_type_id;
	time_t starttime;
	time_t endtime;
};

class Dept
{
public:
	Dept(){};
	~Dept(){};
	Dept(int id, string name);
private:
public:
	int dept_id;
	string dept_name;

	CardMap dept_card_list_person;
	CardMap dept_card_list_vehicle;
};

class OccLevel
{
public:
	OccLevel(){};
	~OccLevel(){};
	OccLevel(int id);
private:
public:
	int occlevel_id;

	CardMap level_card_list_person;
	CardMap level_card_list_vehicle;
};

/*
* ͼ·
*/
class ReaderPath{
public:
	ReaderPath(){
		bIsInit = false;
		nRealCalcPoints = 0;
		x[0] = x[1] = y[0] = y[1] = 0;
		for(int i = 0;i < MAX_CALC_POINTS;i++){
			px[i] = py[i] = pz[i] = 0;
		}
	}
public:
	//TOFԣx,yʾ1,2߶Ӧ
	//TDOAԣx,yʾF1,F2ͬڷվi,i+1
	int nRealCalcPoints;
	double x[2];
	double y[2];
	double z[2];
	double px[MAX_CALC_POINTS];
	double py[MAX_CALC_POINTS];
	double pz[MAX_CALC_POINTS];

	bool bIsInit;
};

//̵
class Light{
public:
	int m_nID;			//̵id
	int m_nMapID;		//ͼid
	int m_nReaderID;	//վid
	int m_nAreaID;		//id
	int m_nSectionID;	//·id
	int m_nLightsGroupID;		//̵id
	int m_nPort;		//վ֮ͨŵ·
	int m_nState;		//̵Ƿ״̬0ã1
	int m_nOldState;
	int device_type_id;	//豸

	double x;	//x
	double y;	//y
	double z;	//z

	std::string m_strIP;	//̵ip
	std::string m_strName;	//̵
	std::string m_strLabel;

	time_t rec_time;
	time_t last_send_time;
public:
	Light();
	~Light(){}
public:
	int get_light_state();

public:
	int m_nStream;		//0ΪУ1Ϊ
	int m_nColor;		//0x01 ɫ, 0x02 ɫ
	int m_nShape;		// ״ 0x01 ʵԲΣ0x02 ԲΣ0x03 Σ0x04 - 0x07 Ҽͷ0xFF ˸
	int m_nStateBiz;	//0Ϊ1Ϊϣ2Ϊʧܣ3Ϊƹ
	int m_nIsCtrl;		// 豸״̬ 0x01 Զƣ0x02ֶ

	time_t alarm_start_time;
};

class LightsGroup{
public:
	int m_nID;
	int m_nState;

	bool m_bIsUsed;

	std::string m_strName;
	std::string m_strLabel;
public:
	int m_nSectionId;		//ڵ·
	std::string m_strVechileId;		//ƴ˵ĳid
	map<int,std::shared_ptr<Light>> mp_lights_list;
public:
	LightsGroup();
	~LightsGroup(){};

public:
	bool isExist(std::shared_ptr<Light> pLight);
	bool isAllLightColor(int nColor);
};

class BaseArea{
public:
	BaseArea(){
		m_nPolygonCount = 0;
		m_pPolygon = NULL;
	}
	~BaseArea(){
		if (m_pPolygon)
		{
			delete[] m_pPolygon;
			m_pPolygon = NULL;
		}
	}
public:
	int init_border(string path);
	bool IsInPolygon(_point p);
private:
	double GetVertex(std::string src); // 
	std::vector<std::string> Split(std::string str,std::string pattern);
public:
	int m_nProperty;
	int m_nPolygonCount;
	_point* m_pPolygon;
};

//
class Chamber:public BaseArea{
public:
	int m_nID;	//ұ
	int m_nState;		//ʹ״ָ̬Ƿڿ
	int m_nIsUsed;		//Ƿг
	int m_nSectionID;	//·ID
	int m_nMapID;		//ͼID

	std::string m_strPath;	//
	std::string m_strName;	//
	std::string m_strLabel;	//

public:
	Chamber();
	~Chamber();
};

//·
class Section:public BaseArea{
public:
	int m_nID;
	int m_nMapId;

	std::string m_strPath;
	std::string m_strName;
	std::string m_strLabel;
public:
	int m_nState;	//0---1---æ2---ӵ

	time_t alarm_start_time;

	ChamberMap mp_champer_list;
	LightMap mp_light_list;
	CardMap mp_vehicle_list;
	CardMap mp_staffer_list;

	INT64 m_event_list[SECTION_EVENT_COUNT];
public:
	Section();
	~Section(){}

public:
	bool is_has_chamber();		//ǷδʹõĶ
	int get_section_state();	//·״̬
	int get_section_vehicle_counts();	//·ڳ
	int get_section_staffer_counts();	//·Ա
};

class PatrolTask
{
public:
	PatrolTask();
	~PatrolTask();

private:
public:
	int patrol_task_id;
	int patrol_path_id;
	string card_id;
	string starffer_id;
	time_t start_time;
	time_t end_time;
	PatrolPointMap mpPoint;

	bool is_in_cur_point;
	int cur_point_idx;
	int state; // Ѳ״̬
	int stay_state; // ͣʱ״̬
	int duration_stay; //ͣʱ
	time_t enter_time; // ýڵʱ
	time_t leave_time; // 뿪ǰڵʱ
};

class PatrolPoint
{
public:
	PatrolPoint();
	~PatrolPoint();
private:
public:
	int idx; // ·е
	int patrol_point_id;
	int map_id;
	double x; // ΧԲ
	double y;
	double z;
	double ranging; // 뷶Χ

	int duration_last;  // ϸڵʱ
	int duration_stay_min; // ڵСʱ
	int duration_stay_max;  // ڵʱ
	int duration_ranging; // ϸڵʱƫ
};

enum EVENT_TYPE{ // ¼
	ET_UNKNOWN = 0,
	ET_OVER_COUNT_PERSON = 1, // ԱԱmp_card_list_over_count_person
	ET_OVER_COUNT_VEHICLE = 2,    // ³Աmp_card_list_over_count_person

	ET_AREA_OVER_COUNT_PERSON = 3,	// ԱԱ
	ET_AREA_OVER_COUNT_VEHICLE = 4,	// Ա

	ET_SECTION_OVER_COUNT = 5, // ·ӵ

	ET_READER_ERROR = 6, // վͨ쳣
	ET_ctrl_reader_ERROR = 7, // Ʒվ쳣
	ET_LIGHT_ERROR = 8, // ͨ쳣
	ET_READER_CALL = 9, // վбʶ
	ET_READER_CALL_CANCEL = 10, // ȡзվ

	ET_CARD_LOW_POWER = 11, // 
	ET_CARD_LOW_POWER_SERIOUS = 12, // 

	ET_CARD_OVER_TIME_PERSON = 13, // Ա³ʱmp_card_list_over_time_person
	ET_CARD_OVER_TIME_VEHICLE = 14, // ³ʱmp_card_list_over_time_vehicle
	ET_CARD_AREA_OVER_TIME_PERSON = 15, // Աʱ
	ET_CARD_AREA_OVER_TIME_VEHICLE = 16, // ʱ
	ET_CARD_AREA_LIMIT_PERSON = 17, // Ա
	ET_CARD_AREA_LIMIT_VEHICLE = 18, // 
	ET_CARD_AREA_FORBIDDEN_PERSON = 19,  // Աֹ
	ET_CARD_AREA_FORBIDDEN_VEHICLE = 20, // ֹ
	ET_CARD_OVER_SPEED = 21, // 
	ET_CARD_AREA_OVER_SPEED = 22, // 
	ET_CARD_RUN_THE_RED_LIGHT = 23, // 
	ET_CARD_HELP = 24, // Ա
	ET_CARD_CALLED = 25, // Աѱ
	ET_CARD_PATROL_ERROR = 26, // ԱѲ쳣
	ET_CARD_LOST = 27, // ʶźŶʧ
	ET_CARD_DRIVINGFACE_WARNING_AREA = 28,  // 濿Ԥ澯
	ET_CARD_NEAR_DRIVINGFACE_VEHICLE=29,// Ա澯
	CARD_EVENT_COUNT_MAX,
};

enum OBJECT_TYPE // 
{
	OT_MINE = 1, // 
	OT_AREA = 2,  // 
	OT_SECTION = 3, // ·
	OT_DEVICE_READER = 4, // վ
	OT_DEVICE_LIGHT = 5, // ͨ
	OT_DEVICE_ctrl_reader = 6, // Ʒվ
	OT_DEVICE_LED = 7, // led
	OT_DEVICE_SPEAKER = 8, // 
	OT_CARD = 9 // ʶԱ
};

enum EVENT_STATUS{ // ¼״̬
	ES_START = 0, // ¼ʼ
	ES_END = 100 // ¼
};

enum REQUEST_COUNTS_TYPE{
	REQUEST_ALL = 0,
	REQUEST_ALL_OVER_TIME_PERSON,
	REQUEST_AREA_OVER_TIME_PERSON,
	REQUEST_SPECIAL_ERROR_PERSON,
	REQUEST_ALL_OVER_TIME_VEHICLE,
	REQUEST_AREA_OVER_TIME_VEHICLE,
	REQUEST_ALL_OVER_PERSON,
	REQUEST_AREA_OVER_PERSON,
	REQUEST_ALL_OVER_VEHICLE,
	REQUEST_AREA_OVER_VEHICLE
};

class YaEvent
{
private:
	INT64 ev_id;
public:

	YaEvent(){};
	YaEvent(INT64 e_id){
		ev_id = e_id;

		obj_id = "";
		cur_time = time(NULL);
		map_id = 0;
		area_id = 0;
		x = 0;
		y = 0;
		limit_value = 0;
		cur_value = 0;
		desc = "";
		landmarkid = 0;
		landmarkdirect = 0;
		landmarkdist = 0;
		is_count = false;
	};
	~YaEvent(){};
public:
	EVENT_STATUS status;

	EVENT_TYPE ev_type;
	OBJECT_TYPE obj_type;
	std::string obj_id;
	time_t cur_time;

	int map_id;
	int area_id;
	double x;
	double y;	
	double limit_value;
	double cur_value;
	std::string desc;
	int landmarkid;
	int landmarkdirect;
	int landmarkdist;

	bool is_sent; // ѷ
	bool is_count;

	INT64 get_id(){return ev_id;};
};

class LightCallInfo{
public:
	LightCallInfo(){
		light_id = 0;
		ctrl_type = 0;
		ctrl_color = 0;
		light_state = 0;
		task_id = "";
	}
public:
	int light_id;
	int ctrl_type;
	int ctrl_color;
	int light_state;
	std::string task_id;
};

enum DIRECTION_TYPE{
	NODIRECTORY = 0,
	EAST = 1,
	SOURTH = 2,
	WEST = 3,
	NORTH = 4
};

class VehicleTypeAttRule
{
public:
	VehicleTypeAttRule(int vtid, int pre, int back);
	~VehicleTypeAttRule();

	int vehicle_type_id;
	int offset_pre;
	int offset_back;
	std::vector<int> vecArea;

	void Clear();
	void AddArea(int area_id);
};
#endif //YASERVER_CLASSDEF_H_